#version 330 core
layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNormal;
layout (location = 2) in vec2 aTexCoords;

out vec3 FragPos;
out vec3 Normal;
out vec2 TexCoords;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform float time;

void main()
{
	float offset = sin(time + (aPos.x + aPos.z) * 20) * 10 + 5;
	float gradient = cos(time + (aPos.x + aPos.z) * 20) * 1;

    FragPos = vec3(model * vec4(aPos, 1.0)) + vec3(0.0, offset, 0.0);

	vec3 slope = vec3(1.0, gradient, 0.0);

    Normal = cross(vec3(0.0, 0.0, 1.0), slope);
    TexCoords = aTexCoords;
    
    gl_Position = projection * view * vec4(FragPos, 1.0);
}