#version 330 core
out vec4 FragColor;

struct Material {
    sampler2D diffuse;
}; 

struct Light {
    //vec3 position;
    vec3 direction;

    vec3 ambient;
    vec3 diffuse;
};

in vec3 FragPos;
in vec3 Normal;
in vec2 TexCoords;
  
uniform vec3 viewPos;
uniform Material material;
uniform Light light;

void main()
{
    // ambient
	vec3 origin = texture(material.diffuse, TexCoords).bbb;
	vec3 tex = origin;

    vec3 ambient = light.ambient * tex;
  	
    // diffuse 
    vec3 norm = normalize(Normal);
    // vec3 lightDir = normalize(light.position - FragPos);
    vec3 lightDir = normalize(-light.direction);  
    float diff = max(dot(norm, lightDir), 0.0);
    vec3 diffuse = light.diffuse * diff * tex;
        
    vec3 result = ambient + diffuse;
    FragColor = vec4(result, 1.0);
} 